## org.eclipse.emf.ecore.util
Class AbstractSequentialInternalEList<E>

    java.lang.Object
      java.util.AbstractCollection<E>
          java.util.AbstractList<E>
              java.util.AbstractSequentialList<E>
                  org.eclipse.emf.ecore.util.AbstractSequentialInternalEList<E>

All Implemented Interfaces:
  java.lang.Iterable<E>, java.util.Collection<E>, java.util.List<E>, EList<E>, InternalEList<E>

Direct Known Subclasses:
  EContentsEList

    public abstract class AbstractSequentialInternalEList<E>

extends java.util.AbstractSequentialList<E>
implements InternalEList<E>

An abstract implementation of `InternalEList`. Clients must override either `basicList()` or `basicListIterator(int)` since these two methods delegate to each other and unless that cycle is broken will lead to stack overflow.

Since:
  2.4

Nested Class Summary

Nested classes/interfaces inherited from interface org.eclipse.emf.ecore.util.InternalEList
`InternalEList.Unsettable<E>`

Field Summary

Fields inherited from class java.util.AbstractList
`modCount`

Constructor Summary
`protected` `AbstractSequentialInternalEList()`

Method Summary
`boolean` `addAllUnique(java.util.Collection<? extends E> collection)` Adds the objects without verifying uniqueness.
`boolean` `addAllUnique(int index, java.util.Collection<? extends E> collection)` Adds the objects without verifying uniqueness.
`void` `addUnique(E object)` Adds the object without verifying uniqueness.
`void` `addUnique(int index, E object)` Adds the object without verifying uniqueness.
`NotificationChain` `basicAdd(E object, NotificationChain notifications)` Adds the object without updating the inverse.
`boolean` `basicContains(java.lang.Object object)` Returns whether the object is contained within the list of unresolved values.
`boolean` `basicContainsAll(java.util.Collection<?> collection)` Returns whether each object in the collection is contained within the list of unresolved values.
`E` `basicGet(int index)` Returns the unresolved value.
`int` `basicIndexOf(java.lang.Object object)` Returns the index of the object within the list of unresolved values.
`java.util.Iterator<E>` `basicIterator()` Returns an iterator that yields unresolved values.
`int` `basicLastIndexOf(java.lang.Object object)` Returns the last index of the object within the list of unresolved values.
`java.util.List<E>` `basicList()` Returns an unmodifiable list that yields unresolved values.
`java.util.ListIterator<E>` `basicListIterator()` Returns a list iterator that yields unresolved values.
`java.util.ListIterator<E>` `basicListIterator(int index)` Returns a list iterator that yields unresolved values.
`NotificationChain` `basicRemove(java.lang.Object object, NotificationChain notifications)` Removes the object with without updating the inverse.
`java.lang.Object[]` `basicToArray()` Returns the array with unresolved values.

`

`<T> T[]`

`

`basicToArray(T[] array)`
Returns the array with unresolved values.

`void` `move(int newPosition, E object)` Moves the object to the new position, if is in the list.
`E` `move(int newPosition, int oldPosition)` Moves the object from the old position to the new position.
`E` `setUnique(int index, E object)` Sets the object without verifying uniqueness.

Methods inherited from class java.util.AbstractSequentialList
`add, addAll, get, iterator, listIterator, remove, set`

Methods inherited from class java.util.AbstractList
`add, clear, equals, hashCode, indexOf, lastIndexOf, listIterator, removeRange, subList`

Methods inherited from class java.util.AbstractCollection
`addAll, contains, containsAll, isEmpty, remove, removeAll, retainAll, size, toArray, toArray, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.List
`add, add, addAll, addAll, clear, contains, containsAll, equals, get, hashCode, indexOf, isEmpty, iterator, lastIndexOf, listIterator, listIterator, remove, remove, removeAll, retainAll, set, size, subList, toArray, toArray`

Constructor Detail

### AbstractSequentialInternalEList

    protected AbstractSequentialInternalEList()

Method Detail

### addAllUnique

    public boolean addAllUnique(java.util.Collection<? extends E> collection)

  Description copied from interface: `InternalEList`
  Adds the objects without verifying uniqueness.

  Specified by:
    `addAllUnique` in interface `InternalEList<E>`

### addAllUnique

    public boolean addAllUnique(int index,
                                java.util.Collection<? extends E> collection)

  Description copied from interface: `InternalEList`
  Adds the objects without verifying uniqueness.

  Specified by:
    `addAllUnique` in interface `InternalEList<E>`

### addUnique

    public void addUnique(E object)

  Description copied from interface: `InternalEList`
  Adds the object without verifying uniqueness.

  Specified by:
    `addUnique` in interface `InternalEList<E>`

### addUnique

    public void addUnique(int index,
                          E object)

  Description copied from interface: `InternalEList`
  Adds the object without verifying uniqueness.

  Specified by:
    `addUnique` in interface `InternalEList<E>`

### basicAdd

    public NotificationChain basicAdd(E object,
                                      NotificationChain notifications)

  Description copied from interface: `InternalEList`
  Adds the object without updating the inverse.

  Specified by:
    `basicAdd` in interface `InternalEList<E>`

### basicGet

    public E basicGet(int index)

  Description copied from interface: `InternalEList`
  Returns the unresolved value.

  Specified by:
    `basicGet` in interface `InternalEList<E>`

### basicIterator

    public java.util.Iterator<E> basicIterator()

  Description copied from interface: `InternalEList`
  Returns an iterator that yields unresolved values.

  Specified by:
    `basicIterator` in interface `InternalEList<E>`

### basicList

    public java.util.List<E> basicList()

  Description copied from interface: `InternalEList`
  Returns an unmodifiable list that yields unresolved values.

  Specified by:
    `basicList` in interface `InternalEList<E>`

### basicListIterator

    public java.util.ListIterator<E> basicListIterator()

  Description copied from interface: `InternalEList`
  Returns a list iterator that yields unresolved values.

  Specified by:
    `basicListIterator` in interface `InternalEList<E>`

### basicListIterator

    public java.util.ListIterator<E> basicListIterator(int index)

  Description copied from interface: `InternalEList`
  Returns a list iterator that yields unresolved values.

  Specified by:
    `basicListIterator` in interface `InternalEList<E>`

### basicRemove

    public NotificationChain basicRemove(java.lang.Object object,
                                         NotificationChain notifications)

  Description copied from interface: `InternalEList`
  Removes the object with without updating the inverse.

  Specified by:
    `basicRemove` in interface `InternalEList<E>`

### basicContains

    public boolean basicContains(java.lang.Object object)

  Description copied from interface: `InternalEList`
  Returns whether the object is contained within the list of unresolved values.

  Specified by:
    `basicContains` in interface `InternalEList<E>`

### basicContainsAll

    public boolean basicContainsAll(java.util.Collection<?> collection)

  Description copied from interface: `InternalEList`
  Returns whether each object in the collection is contained within the list of unresolved values.

  Specified by:
    `basicContainsAll` in interface `InternalEList<E>`

### basicIndexOf

    public int basicIndexOf(java.lang.Object object)

  Description copied from interface: `InternalEList`
  Returns the index of the object within the list of unresolved values.

  Specified by:
    `basicIndexOf` in interface `InternalEList<E>`

### basicLastIndexOf

    public int basicLastIndexOf(java.lang.Object object)

  Description copied from interface: `InternalEList`
  Returns the last index of the object within the list of unresolved values.

  Specified by:
    `basicLastIndexOf` in interface `InternalEList<E>`

### basicToArray

    public java.lang.Object[] basicToArray()

  Description copied from interface: `InternalEList`
  Returns the array with unresolved values.

  Specified by:
    `basicToArray` in interface `InternalEList<E>`

### basicToArray

    public <T> T[] basicToArray(T[] array)

  Description copied from interface: `InternalEList`
  Returns the array with unresolved values.

  Specified by:
    `basicToArray` in interface `InternalEList<E>`

### setUnique

    public E setUnique(int index,
                       E object)

  Description copied from interface: `InternalEList`
  Sets the object without verifying uniqueness.

  Specified by:
    `setUnique` in interface `InternalEList<E>`

### move

    public void move(int newPosition,
                     E object)

  Description copied from interface: `EList`
  Moves the object to the new position, if is in the list.

  Specified by:
    `move` in interface `EList<E>`
  Parameters:
    `newPosition` - the position of the object after the move.
    `object` - the object to move.

### move

    public E move(int newPosition,
                  int oldPosition)

  Description copied from interface: `EList`
  Moves the object from the old position to the new position.

  Specified by:
    `move` in interface `EList<E>`
  Parameters:
    `newPosition` - the position of the object after the move.
    `oldPosition` - the position of the object before the move.
  Returns:
    the moved object.

Copyright 2001-2006 IBM Corporation and others. All Rights Reserved.